Package org.jbpm.services.task.audit

## Class JPATaskLifeCycleEventListener

- java.lang.Object
- - org.jbpm.services.task.persistence.PersistableEventListener
  - - org.jbpm.services.task.audit.JPATaskLifeCycleEventListener

- All Implemented Interfaces:
    `EventListener`, `AuditLoggerArchiveTreat`, `TaskLifeCycleEventListener`, `org.kie.api.task.TaskLifeCycleEventListener`

      public class JPATaskLifeCycleEventListener
      extends PersistableEventListener
      implements TaskLifeCycleEventListener, AuditLoggerArchiveTreat

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.kie.api.task.TaskLifeCycleEventListener

      `org.kie.api.task.TaskLifeCycleEventListener.AssignmentType`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `METADATA_AUDIT_TASK` |
    `static String` | `METADATA_TASK_EVENT` |
    `static String` | `METADATA_VAR_EVENT` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JPATaskLifeCycleEventListener​(boolean flag)` |
    `JPATaskLifeCycleEventListener​(javax.persistence.EntityManagerFactory emf)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `afterTaskActivatedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskAddedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskAssignmentsAddedEvent​(org.kie.api.task.TaskEvent event, org.kie.api.task.TaskLifeCycleEventListener.AssignmentType type, List<org.kie.api.task.model.OrganizationalEntity> entities)` |
    `void` | `afterTaskAssignmentsRemovedEvent​(org.kie.api.task.TaskEvent event, org.kie.api.task.TaskLifeCycleEventListener.AssignmentType type, List<org.kie.api.task.model.OrganizationalEntity> entities)` |
    `void` | `afterTaskClaimedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskCompletedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskDelegatedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskExitedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskFailedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskForwardedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskInputVariableChangedEvent​(org.kie.api.task.TaskEvent event, Map<String,​Object> variables)` |
    `void` | `afterTaskNominatedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskNotificationEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskOutputVariableChangedEvent​(org.kie.api.task.TaskEvent event, Map<String,​Object> variables)` |
    `void` | `afterTaskReassignedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskReleasedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskResumedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskSkippedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskStartedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskStoppedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskSuspendedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `afterTaskUpdatedEvent​(org.kie.api.task.TaskEvent event)` |
    `protected void` | `assignmentsUpadted​(org.kie.api.task.TaskEvent event, org.kie.api.task.TaskLifeCycleEventListener.AssignmentType type, List<org.kie.api.task.model.OrganizationalEntity> entities, String messageSufix)` |
    `void` | `beforeTaskActivatedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskAddedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskClaimedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskCompletedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskDelegatedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskExitedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskFailedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskForwardedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskNominatedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskNotificationEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskReassignedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskReleasedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskResumedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskSkippedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskStartedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskStoppedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskSuspendedEvent​(org.kie.api.task.TaskEvent event)` |
    `void` | `beforeTaskUpdatedEvent​(org.kie.api.task.TaskEvent event)` |
    `boolean` | `equals​(Object obj)` |
    `protected String` | `getActualOwner​(org.kie.api.task.model.Task ti)` |
    `protected AuditTaskImpl` | `getAuditTask​(org.kie.api.task.TaskEvent event, org.kie.internal.task.api.TaskPersistenceContext persistenceContext, org.kie.api.task.model.Task ti)` |
    `String` | `getUpdateFieldLog​(String fieldName, String previousValue, String value)` |
    `int` | `hashCode()` |
    `protected void` | `indexAndPersistVariables​(org.kie.api.task.TaskEvent event, org.kie.api.task.model.Task task, Map<String,​Object> variables, org.kie.internal.task.api.TaskPersistenceContext persistenceContext, org.kie.internal.task.api.TaskVariable.VariableType type)` |

    - ### Methods inherited from class org.jbpm.services.task.persistence.PersistableEventListener

      `cleanup, getPersistenceContext`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.jbpm.process.audit.AuditLoggerArchiveTreat

      `initArchiveLoggerProvider`

    - ### Methods inherited from interface org.kie.api.task.TaskLifeCycleEventListener

      `beforeTaskAssignmentsAddedEvent, beforeTaskAssignmentsRemovedEvent, beforeTaskInputVariableChangedEvent, beforeTaskOutputVariableChangedEvent`

- - ### Field Detail

    - #### METADATA_TASK_EVENT

          public static final String METADATA_TASK_EVENT

      See Also:
        Constant Field Values

    - #### METADATA_AUDIT_TASK

          public static final String METADATA_AUDIT_TASK

      See Also:
        Constant Field Values

    - #### METADATA_VAR_EVENT

          public static final String METADATA_VAR_EVENT

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### JPATaskLifeCycleEventListener

          public JPATaskLifeCycleEventListener​(boolean flag)

    - #### JPATaskLifeCycleEventListener

          public JPATaskLifeCycleEventListener​(javax.persistence.EntityManagerFactory emf)

  - ### Method Detail

    - #### afterTaskStartedEvent

          public void afterTaskStartedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskStartedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskActivatedEvent

          public void afterTaskActivatedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskActivatedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskClaimedEvent

          public void afterTaskClaimedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskClaimedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskSkippedEvent

          public void afterTaskSkippedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskSkippedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskStoppedEvent

          public void afterTaskStoppedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskStoppedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskCompletedEvent

          public void afterTaskCompletedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskCompletedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskFailedEvent

          public void afterTaskFailedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskFailedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskAddedEvent

          public void afterTaskAddedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskAddedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskExitedEvent

          public void afterTaskExitedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskExitedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskReleasedEvent

          public void afterTaskReleasedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskReleasedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskResumedEvent

          public void afterTaskResumedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskResumedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskSuspendedEvent

          public void afterTaskSuspendedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskSuspendedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskForwardedEvent

          public void afterTaskForwardedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskForwardedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskDelegatedEvent

          public void afterTaskDelegatedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskDelegatedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskNominatedEvent

          public void afterTaskNominatedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskNominatedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### getAuditTask

          protected AuditTaskImpl getAuditTask​(org.kie.api.task.TaskEvent event,
                                               org.kie.internal.task.api.TaskPersistenceContext persistenceContext,
                                               org.kie.api.task.model.Task ti)

    - #### beforeTaskActivatedEvent

          public void beforeTaskActivatedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskActivatedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskClaimedEvent

          public void beforeTaskClaimedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskClaimedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskSkippedEvent

          public void beforeTaskSkippedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskSkippedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskStartedEvent

          public void beforeTaskStartedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskStartedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskStoppedEvent

          public void beforeTaskStoppedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskStoppedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskCompletedEvent

          public void beforeTaskCompletedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskCompletedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskFailedEvent

          public void beforeTaskFailedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskFailedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskAddedEvent

          public void beforeTaskAddedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskAddedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskExitedEvent

          public void beforeTaskExitedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskExitedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskReleasedEvent

          public void beforeTaskReleasedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskReleasedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskResumedEvent

          public void beforeTaskResumedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskResumedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskSuspendedEvent

          public void beforeTaskSuspendedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskSuspendedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskForwardedEvent

          public void beforeTaskForwardedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskForwardedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskDelegatedEvent

          public void beforeTaskDelegatedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskDelegatedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskNominatedEvent

          public void beforeTaskNominatedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskNominatedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### equals

          public boolean equals​(Object obj)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### beforeTaskUpdatedEvent

          public void beforeTaskUpdatedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskUpdatedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### getUpdateFieldLog

          public String getUpdateFieldLog​(String fieldName,
                                          String previousValue,
                                          String value)

    - #### afterTaskUpdatedEvent

          public void afterTaskUpdatedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskUpdatedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskReassignedEvent

          public void beforeTaskReassignedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskReassignedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskReassignedEvent

          public void afterTaskReassignedEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskReassignedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### beforeTaskNotificationEvent

          public void beforeTaskNotificationEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `beforeTaskNotificationEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskNotificationEvent

          public void afterTaskNotificationEvent​(org.kie.api.task.TaskEvent event)

      Specified by:
        `afterTaskNotificationEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskOutputVariableChangedEvent

          public void afterTaskOutputVariableChangedEvent​(org.kie.api.task.TaskEvent event,
                                                          Map<String,​Object> variables)

      Specified by:
        `afterTaskOutputVariableChangedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskInputVariableChangedEvent

          public void afterTaskInputVariableChangedEvent​(org.kie.api.task.TaskEvent event,
                                                         Map<String,​Object> variables)

      Specified by:
        `afterTaskInputVariableChangedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### indexAndPersistVariables

          protected void indexAndPersistVariables​(org.kie.api.task.TaskEvent event,
                                                  org.kie.api.task.model.Task task,
                                                  Map<String,​Object> variables,
                                                  org.kie.internal.task.api.TaskPersistenceContext persistenceContext,
                                                  org.kie.internal.task.api.TaskVariable.VariableType type)

    - #### afterTaskAssignmentsAddedEvent

          public void afterTaskAssignmentsAddedEvent​(org.kie.api.task.TaskEvent event,
                                                     org.kie.api.task.TaskLifeCycleEventListener.AssignmentType type,
                                                     List<org.kie.api.task.model.OrganizationalEntity> entities)

      Specified by:
        `afterTaskAssignmentsAddedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### afterTaskAssignmentsRemovedEvent

          public void afterTaskAssignmentsRemovedEvent​(org.kie.api.task.TaskEvent event,
                                                       org.kie.api.task.TaskLifeCycleEventListener.AssignmentType type,
                                                       List<org.kie.api.task.model.OrganizationalEntity> entities)

      Specified by:
        `afterTaskAssignmentsRemovedEvent` in interface `org.kie.api.task.TaskLifeCycleEventListener`

    - #### assignmentsUpadted

          protected void assignmentsUpadted​(org.kie.api.task.TaskEvent event,
                                            org.kie.api.task.TaskLifeCycleEventListener.AssignmentType type,
                                            List<org.kie.api.task.model.OrganizationalEntity> entities,
                                            String messageSufix)

    - #### getActualOwner

          protected String getActualOwner​(org.kie.api.task.model.Task ti)